//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System.Linq;
using Tecan.Sila2;
using Tecan.Sila2.Client;
using Tecan.Sila2.Server;

namespace Tecan.Sila2.ConnectionConfiguration.ConnectionConfigurationService
{
    
    
    /// <summary>
    /// Class that implements the IConnectionConfigurationService interface through SiLA2
    /// </summary>
    public partial class ConnectionConfigurationServiceClient : IConnectionConfigurationService
    {
        
        private System.Lazy<bool> _serverInitiatedConnectionModeStatus;
        
        private System.Lazy<System.Collections.Generic.ICollection<ConfiguredSiLAClient>> _configuredSiLAClients;
        
        private IClientExecutionManager _executionManager;
        
        private IClientChannel _channel;
        
        private const string _serviceName = "sila2.org.silastandard.core.connectionconfigurationservice.v1.ConnectionConfigura" +
            "tionService";
        
        /// <summary>
        /// Creates a new instance
        /// </summary>
        /// <param name="channel">The channel through which calls should be executed</param>
        /// <param name="executionManager">A component to determine metadata to attach to any requests</param>
        public ConnectionConfigurationServiceClient(IClientChannel channel, IClientExecutionManager executionManager)
        {
            _executionManager = executionManager;
            _channel = channel;
            InitLazyRequests();
        }
        
        /// <summary>
        /// Whether or not the server initiated connection mode is active.
        /// </summary>
        public virtual bool ServerInitiatedConnectionModeStatus
        {
            get
            {
                return _serverInitiatedConnectionModeStatus.Value;
            }
        }
        
        /// <summary>
        /// Get the configured SiLA Clients used for server-initiated connections.
        /// </summary>
        public virtual System.Collections.Generic.ICollection<ConfiguredSiLAClient> ConfiguredSiLAClients
        {
            get
            {
                return _configuredSiLAClients.Value;
            }
        }
        
        private bool RequestServerInitiatedConnectionModeStatus()
        {
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/core/ConnectionConfigurationService/v1/Property/ServerInitiatedC" +
                    "onnectionModeStatus");
            try
            {
                bool response = _channel.ReadProperty<PropertyResponse<Tecan.Sila2.BooleanDto>>(_serviceName, "ServerInitiatedConnectionModeStatus", "org.silastandard/core/ConnectionConfigurationService/v1/Property/ServerInitiatedC" +
                        "onnectionModeStatus", callInfo).Value.Extract(_executionManager.DownloadBinaryStore);
                callInfo.FinishSuccessful();
                return response;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        private System.Collections.Generic.ICollection<ConfiguredSiLAClient> RequestConfiguredSiLAClients()
        {
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/core/ConnectionConfigurationService/v1/Property/ConfiguredSiLACl" +
                    "ients");
            try
            {
                System.Collections.Generic.ICollection<ConfiguredSiLAClient> response = _channel.ReadProperty<PropertyResponse<System.Collections.Generic.List<ConfiguredSiLAClientDto>>>(_serviceName, "ConfiguredSiLAClients", "org.silastandard/core/ConnectionConfigurationService/v1/Property/ConfiguredSiLACl" +
                        "ients", callInfo).Value.Extract(_executionManager.DownloadBinaryStore);
                callInfo.FinishSuccessful();
                return response;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        /// <summary>
        /// Initializes lazies for non-observable properties.
        /// </summary>
        private void InitLazyRequests()
        {
            _serverInitiatedConnectionModeStatus = new System.Lazy<bool>(RequestServerInitiatedConnectionModeStatus);
            _configuredSiLAClients = new System.Lazy<System.Collections.Generic.ICollection<ConfiguredSiLAClient>>(RequestConfiguredSiLAClients);
        }
        
        /// <summary>
        /// Enable the server initiated connection mode.
        /// </summary>
        public virtual void EnableServerInitiatedConnectionMode()
        {
            EnableServerInitiatedConnectionModeRequestDto request = new EnableServerInitiatedConnectionModeRequestDto(null);
            request.Validate();
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/core/ConnectionConfigurationService/v1/Command/EnableServerIniti" +
                    "atedConnectionMode");
            try
            {
                _channel.ExecuteUnobservableCommand<EnableServerInitiatedConnectionModeRequestDto>(_serviceName, "EnableServerInitiatedConnectionMode", request, callInfo);
                callInfo.FinishSuccessful();
                return;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        /// <summary>
        /// Disable the server initiated connection mode.
        /// </summary>
        public virtual void DisableServerInitiatedConnectionMode()
        {
            DisableServerInitiatedConnectionModeRequestDto request = new DisableServerInitiatedConnectionModeRequestDto(null);
            request.Validate();
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/core/ConnectionConfigurationService/v1/Command/DisableServerInit" +
                    "iatedConnectionMode");
            try
            {
                _channel.ExecuteUnobservableCommand<DisableServerInitiatedConnectionModeRequestDto>(_serviceName, "DisableServerInitiatedConnectionMode", request, callInfo);
                callInfo.FinishSuccessful();
                return;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        /// <summary>
        /// Connect a new SiLA Client.
        /// </summary>
        /// <param name="clientName">Human readable name of the SiLA Client. Has to be unique.</param>
        /// <param name="siLAClientHost">Host Address of the new SiLA Client.</param>
        /// <param name="siLAClientPort">Port of the new SiLA Client.</param>
        /// <param name="persist">Whether or not the connection should be persisted.</param>
        public virtual void ConnectSiLAClient(string clientName, string siLAClientHost, long siLAClientPort, bool persist)
        {
            ConnectSiLAClientRequestDto request = new ConnectSiLAClientRequestDto(clientName, siLAClientHost, siLAClientPort, persist, null);
            request.Validate();
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/core/ConnectionConfigurationService/v1/Command/ConnectSiLAClient" +
                    "");
            try
            {
                _channel.ExecuteUnobservableCommand<ConnectSiLAClientRequestDto>(_serviceName, "ConnectSiLAClient", request, callInfo);
                callInfo.FinishSuccessful();
                return;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        /// <summary>
        /// Disconnect a configured SiLA Client.
        /// </summary>
        /// <param name="clientName">Human readable name of the SiLA Client.</param>
        /// <param name="remove">Whether or not to remove the connection details.</param>
        public virtual void DisconnectSiLAClient(string clientName, bool remove)
        {
            DisconnectSiLAClientRequestDto request = new DisconnectSiLAClientRequestDto(clientName, remove, null);
            request.Validate();
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/core/ConnectionConfigurationService/v1/Command/DisconnectSiLACli" +
                    "ent");
            try
            {
                _channel.ExecuteUnobservableCommand<DisconnectSiLAClientRequestDto>(_serviceName, "DisconnectSiLAClient", request, callInfo);
                callInfo.FinishSuccessful();
                return;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        private T Extract<T>(Tecan.Sila2.ISilaTransferObject<T> dto)
        
        {
            return dto.Extract(_executionManager.DownloadBinaryStore);
        }
    }
    
    /// <summary>
    /// Factory to instantiate clients for the Connection Configuration Service.
    /// </summary>
    [System.ComponentModel.Composition.ExportAttribute(typeof(IClientFactory))]
    [System.ComponentModel.Composition.PartCreationPolicyAttribute(System.ComponentModel.Composition.CreationPolicy.Shared)]
    public partial class ConnectionConfigurationServiceClientFactory : IClientFactory
    {
        
        /// <summary>
        /// Gets the fully-qualified identifier of the feature for which clients can be generated
        /// </summary>
        public string FeatureIdentifier
        {
            get
            {
                return "org.silastandard/core/ConnectionConfigurationService/v1";
            }
        }
        
        /// <summary>
        /// Gets the interface type for which clients can be generated
        /// </summary>
        public System.Type InterfaceType
        {
            get
            {
                return typeof(IConnectionConfigurationService);
            }
        }
        
        /// <summary>
        /// Creates a strongly typed client for the given execution channel and execution manager
        /// </summary>
        /// <param name="channel">The channel that should be used for communication with the server</param>
        /// <param name="executionManager">The execution manager to manage metadata</param>
        /// <returns>A strongly typed client. This object will be an instance of the InterfaceType property</returns>
        public object CreateClient(IClientChannel channel, IClientExecutionManager executionManager)
        {
            return new ConnectionConfigurationServiceClient(channel, executionManager);
        }
    }
}

